# Author:: Toshiro Sugii
# Copyright:: Copyright (c) 2016 Toshiro Sugii
# License::   Distributes under the same terms as Ruby
require 'jaspion/miya/version'

require 'jaspion/miya/object'
require 'jaspion/miya/template'

# requires all android templates
require 'jaspion/miya/android'
Dir[File.dirname(__FILE__) + '/miya/android/*.rb'].each { |file| require file }

# requires all objectivec templates
require 'jaspion/miya/objectivec'
Dir[File.dirname(__FILE__) + '/miya/objectivec/*.rb'].each { |file| require file }

# requires all swift templates
require 'jaspion/miya/swift'
Dir[File.dirname(__FILE__) + '/miya/swift/*.rb'].each { |file| require file }

# Native Ruby class
class String
  # "Un"capitalizes an String
  def uncapitalize
    self[0, 1].downcase + self[1..-1]
  end
end

# Native Ruby class
class Class
  # Returns all descendants classes
  def descendants
    cls = ObjectSpace.each_object(Class).select { |klass| klass < self }
    cls.sort! { |a,b| a.name.downcase <=> b.name.downcase }
  end
end

module Jaspion
  # Module Miya
  module Miya
  end
end
