# Author:: Toshiro Sugii
# Copyright:: Copyright (c) 2016 Toshiro Sugii
# License::   Distributes under the same terms as Ruby
require 'jaspion/miya/object'

module Jaspion
  module Miya
    # Represents an Android Object class
    class Android < Miya::Object
      attr_accessor :package

      def instance_variables
        "    private #{type} #{name.uncapitalize};"
      end

      def ui?
        self.class.name.include?('View') || self.class.name.include?('Edit')
      end

      # Represents the Java class package
      def package
        @package = '' if @package.nil?
        @package
      end

      # Generates inflating parameters
      #
      # @return [String] An initializer for this object view, if ui?
      def inflate_view
        if ui?
          str = "        this.#{name.uncapitalize} = (#{type})"
          str << " findViewById(R.id.#{name.downcase});"
          return str
        end
        ''
      end
    end
  end
end
