# Author:: Toshiro Sugii
# Copyright:: Copyright (c) 2016 Toshiro Sugii
# License::   Distributes under the same terms as Ruby
module Jaspion
  module Miya
    class Android
      # Represents an Android Retrofit template
      # (http://square.github.io/retrofit/)
      class Retrofit < Miya::Android
        def imports
          %(
import com.squareup.okhttp.OkHttpClient;
import com.squareup.okhttp.ResponseBody;
import com.squareup.okhttp.logging.HttpLoggingInterceptor;
import retrofit.Call;
import retrofit.Callback;
import retrofit.GsonConverterFactory;
import retrofit.Response;
import retrofit.Retrofit;
import #{name}RESTInterface;)
        end

        def instance_variables
          "    private #{name}RESTInterface #{name.uncapitalize}RESTInterface;"
        end

        def instance_methods
          %(
    protected void loadRetrofit() {
        if (BuildConfig.DEBUG) {
            HttpLoggingInterceptor logging = new HttpLoggingInterceptor();
            logging.setLevel(HttpLoggingInterceptor.Level.BASIC);
            OkHttpClient httpClient = new OkHttpClient();
            httpClient.interceptors().add(logging);
        }

        this.#{name} = new Retrofit.Builder()
            .baseUrl(#{name}RESTInterface.BASE_URL)
            .addConverterFactory(GsonConverterFactory.create())
            .client(httpClient)
            .build();

        this.#{name.uncapitalize}RESTInterface = retrofit.create(#{name}RESTInterface.class);
    })
        end
      end
    end
  end
end
