# Author:: Toshiro Sugii
# Copyright:: Copyright (c) 2016 Toshiro Sugii
# License::   Distributes under the same terms as Ruby
require 'jaspion/miya/object'

module Jaspion
  module Miya
    # Represents an Objective-C Object class
    class Objectivec < Miya::Object
      attr_accessor :xib_reference
      alias xib_reference? xib_reference

      def initialize(name = nil)
        super(name)
        @xib_reference = true
      end

      def instance_variables
        str = super
        if xib_reference? && ui?
          str << "\n    IBOutlet @property (nonatomic, weak)"
        else
          str << "\n    @property (nonatomic, strong)"
        end
        str << " #{type} *#{name.uncapitalize};"
        str
      end

      def interface_methods
        ''
      end

      def protocols
        []
      end

      def ui?
        self.class.name.include?('View')
      end
    end
  end
end
